/******************************************
Program : USART1 (RS485 PORT) Example for Micro128
Company : Micromint, Inc
*********************************************/
     
#include <mega128.h>
#include <MMRS485.h>     // Micromints Library for using both USARTs
#include <stdio.h>      // Standard I/O library
#include <delay.h>			// Library for delays  
#include <bcd.h>   
// Declare your global variables here
int COM;         // if COM = 0 then use USART0 if it = 1 then use USART1     
unsigned int x @0xFFE;
void(*UtilityVersion)(void)=0xFC1E;

void main(void)
{
// Declare your local variables here

// Set up USART0's Baud rate at 9600 bps with a 11.0592 MHz Crystal
UCSR0A=0x00;
UCSR0B=0x18;
UCSR0C=0x06;
UBRR0H=0x00;
UBRR0L=0x47;

// Set up USART1's Baud rate at 9600 bps with a 11.0592 MHz Crystal
UCSR1A=0x00;      // RX EN, TX EN
UCSR1B=0x18;     // RX EN, TX EN
UCSR1C=0x06;     // 8N1
UBRR1H=0x00;    // Baud rate high - 9600
UBRR1L=0x47;   // Baud rate low 
 
while (1)
      {
      COM = 1;                           // Use USART1  
      DDRD.6 = 0;			   // Make PORTD.6 an output  
      PORTD.6 = 1; 			   // Enable the RS485 control line                     
      (*UtilityVersion)();
      printf("Utility Version = %02d\r\n",bcd2bin(x));         
      delay_ms(500);          //Wait for th transmission to finish
      PORTD.6 = 0; 			   // Disable the RS485 control line                 
      };
}
